[PATCH 2/5] erofs-utils: tests: add test for xattrs
Jingbo Xu
jefflexu at linux.alibaba.com
Thu May 25 18:31:58 AEST 2023
From: Huang Jianan <huangjianan at oppo.com>
Add basic functional check for xattrs.
Signed-off-by: Huang Jianan <huangjianan at oppo.com>
Signed-off-by: Jeffle Xu <jefflexu at linux.alibaba.com>
---
tests/Makefile.am | 3 +++
tests/erofs/019 | 55 +++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/erofs/019.out | 2 ++
3 files changed, 60 insertions(+)
create mode 100755 tests/erofs/019
create mode 100644 tests/erofs/019.out
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 3bd6ad5..b85ae89 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -88,6 +88,9 @@ TESTS += erofs/017
# 018 - verify lzma compressed image
TESTS += erofs/018
+# 019 - check extended attribute functionality
+TESTS += erofs/019
+
EXTRA_DIST = common/rc erofs
clean-local: clean-local-check
diff --git a/tests/erofs/019 b/tests/erofs/019
new file mode 100755
index 0000000..0b89b77
--- /dev/null
+++ b/tests/erofs/019
@@ -0,0 +1,55 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0+
+#
+# 019 - check extended attribute functionality
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$(echo $0 | awk '{print $((NF-1))"/"$NF}' FS="/")
+
+# get standard environment, filters and checks
+. "${srcdir}/common/rc"
+
+cleanup()
+{
+ cd /
+ rm -rf $tmp.*
+}
+
+_require_erofs
+_require_xattr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+echo "QA output created by $seq"
+
+if [ -z $SCRATCH_DEV ]; then
+ SCRATCH_DEV=$tmp/erofs_$seq.img
+ rm -f SCRATCH_DEV
+fi
+
+localdir="$tmp/$seq"
+rm -rf $localdir
+mkdir -p $localdir
+
+# set random xattrs
+cp -nR ../ $localdir
+dirs=`ls $localdir`
+for d in $dirs; do
+ key=`head -20 /dev/urandom | cksum | cut -f1 -d " "`
+ val="0s"`head -3 /dev/urandom | base64 -w0`
+ setfattr -n user.$key -v $val $localdir/$d
+done
+
+_scratch_mkfs $localdir >> $seqres.full 2>&1 || _fail "failed to mkfs"
+_scratch_mount 2>>$seqres.full
+
+# check xattrs
+_check_xattrs $localdir $SCRATCH_MNT
+
+_scratch_unmount
+
+echo Silence is golden
+status=0
+exit 0
diff --git a/tests/erofs/019.out b/tests/erofs/019.out
new file mode 100644
index 0000000..163484b
--- /dev/null
+++ b/tests/erofs/019.out
@@ -0,0 +1,2 @@
+QA output created by 019
+Silence is golden
--
1.8.3.1
More information about the Linux-erofs
mailing list